#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node13.html#SECTION00130 */

void NSN(char *x, int m, char *y, int n) {
  int j, k, ell;
  
  /* Preprocessing */
  if (x[0] == x[1]) {
    k = 2;
    ell = 1;
  }
  else {
    k = 1;
    ell = 2;
  }
  
  /* Searching */
  j = 0;
  set_txt_length(n);
  while (j <= n - m) {
    start_pruning_duplicates();
    if (x[1] != trace_get(y, j + 1))
      j += k;
    else {
      if (trace_memcmp(x + 2, y + j + 2, m - 2, j + 2) == 0 
          && x[0] == trace_get(y, j))
        OUTPUT(j);
      j += ell;
    }
    stop_pruning_duplicates();

    /* if (x[1] != y[j + 1]) */
    /*   j += k; */
    /* else { */
    /*   if (memcmp(x + 2, y + j + 2, m - 2) == 0 && */
    /*       x[0] == y[j]) */
    /*     OUTPUT(j); */
    /*   j += ell; */
    /* } */
  }
}

List not_so_naive(char* pattern, int pattern_size, 
                           char* text, int text_size) {
  return string_matcher_array(NSN, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(NSN, argc, argv);
}
