#include "utils.h"

void rohde05_naive_(char *pattern, int m, char *text, int n) {
  int i, k;
  i = k = 0;
  while (i < m && k < n) {
    if (pattern[i] == trace_get(text, k)) {
      k++;
      i++;
    } else {
      k = k - i + 1;
      i = 0;
    }
  }
  return;
  /* if (i == m) */
  /*   return k - i; */
  /* else */
  /*   return -1; */
}

List rohde05_naive(char* pattern, int pattern_size, 
                   char* text, int text_size) {
  return string_matcher_array(rohde05_naive_, 
                              pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(rohde05_naive_, argc, argv);
}
