#include <libguile.h>

SCM test() {
  return scm_from_signed_integer(42);
}

int test1(int i) {
  return i + 1;
}

SCM test1_wrapper (SCM i) {
  return scm_from_signed_integer(test1(scm_to_int32(i)));
}

void init_test () {
  scm_c_define_gsubr("test", 0, 0, 0, test);
  scm_c_define_gsubr("test1", 1, 0, 0, test1);
}

/* 
gcc `guile-config compile` `guile-config link` -shared \
  -o test.so -fPIC test.c

guile
> (dynamic-call "init_test" (dynamic-link "./test.so"))
> (test)

 */
