#ifndef UTILS_H_
#define UTILS_H_
#include <stdint.h>
#include "linkedlist.h"

#define OUTPUT(x) return; 

#define ASIZE 128 /* Alphabeth size (ASCII) */
#define XSIZE 20  /* max pattern size */

void set_txt_length(int n);
void start_pruning_duplicates();
void stop_pruning_duplicates();

void trace_new();

void trace_add(int j);

void trace_print();

void trace(int j);
char trace_get(char *txt, int j);
int trace_memcmp(char *pat, char *txt, int length, int txt_offset);

int string_matcher_main(void (*matcher)(char*, int, char*, int), 
                        int argc, char* argv[]);

void error(char* str);

/* #define MAX(a, b) (a > b ? a : b) */
int MAX(int a, int b);
/* #define MIN(a, b) (a < b ? a : b) */
int MIN(int a, int b);

List string_matcher_array(void (*matcher)(char*, int, char*, int), 
                          char* pattern, int pattern_size, 
                          char* text, int text_size);
#endif /* !UTILS_H_ */
